<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>physicallayer/messaging.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">physicallayer/messaging.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2008 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PL_MESSAGING</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PL_MESSAGING</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/set_8h.html">csutil/set.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scfarray_8h.html">csutil/scfarray.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/iutil_2strset_8h.html">iutil/strset.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;physicallayer/datatype.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">struct </span><a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>;
<a name="l00031"></a>00031 <span class="keyword">struct </span><a class="code" href="structiMessageDispatcher.html" title="This is a message dispatcher.">iMessageDispatcher</a>;
<a name="l00032"></a>00032 <span class="keyword">struct </span><a class="code" href="structiMessageReceiver.html" title="Implement this interface if you are interested in receiving messages.">iMessageReceiver</a>;
<a name="l00033"></a>00033 <span class="keyword">struct </span><a class="code" href="structiMessageReceiverFilter.html" title="This is a filter used for a message dispatcher.">iMessageReceiverFilter</a>;
<a name="l00034"></a>00034 <span class="keyword">struct </span><a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a>;
<a name="l00035"></a>00035 
<a name="l00046"></a><a class="code" href="structiMessageChannel.html">00046</a> <span class="keyword">struct </span><a class="code" href="structiMessageChannel.html" title="This is an message channel.">iMessageChannel</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   SCF_INTERFACE (<a class="code" href="structiMessageChannel.html" title="This is an message channel.">iMessageChannel</a>, 0, 0, 1);
<a name="l00049"></a>00049 
<a name="l00059"></a>00059   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iMessageDispatcher&gt;</a> <a class="code" href="structiMessageChannel.html#a3924e81bc1a707069410f269cfde5755" title="Create a message dispatcher.">CreateMessageDispatcher</a> (
<a name="l00060"></a>00060       <a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a>* sender, <span class="keyword">const</span> <span class="keywordtype">char</span>* msg_id,
<a name="l00061"></a>00061       <a class="code" href="structiMessageReceiverFilter.html" title="This is a filter used for a message dispatcher.">iMessageReceiverFilter</a>* receiver_filter = 0) = 0;
<a name="l00062"></a>00062 
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiMessageChannel.html#a5679fd82dd52d60223e1680331f0cab6" title="Remove a message dispatcher.">RemoveMessageDispatcher</a> (<a class="code" href="structiMessageDispatcher.html" title="This is a message dispatcher.">iMessageDispatcher</a>* msgdest) = 0; 
<a name="l00070"></a>00070 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiMessageChannel.html#aa45f478fc0374e0cadc1db967a1514e1" title="Subscribe to this channel for all messages that match with the given mask.">Subscribe</a> (<a class="code" href="structiMessageReceiver.html" title="Implement this interface if you are interested in receiving messages.">iMessageReceiver</a>* receiver, <span class="keyword">const</span> <span class="keywordtype">char</span>* mask) = 0;
<a name="l00076"></a>00076 
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiMessageChannel.html#a150fb15e18ac345332769d624992cb83" title="Unsubscribe from this channel.">Unsubscribe</a> (<a class="code" href="structiMessageReceiver.html" title="Implement this interface if you are interested in receiving messages.">iMessageReceiver</a>* receiver,
<a name="l00084"></a>00084     <span class="keyword">const</span> <span class="keywordtype">char</span>* mask = 0) = 0;
<a name="l00085"></a>00085 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiMessageChannel.html#a57bd9de92848f0a9b69d297c4af663a3" title="Send a message for a specific message id.">SendMessage</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* msgid,
<a name="l00102"></a>00102       <a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a>* sender, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params,
<a name="l00103"></a>00103       iCelDataArray* ret = 0) = 0;
<a name="l00104"></a>00104 };
<a name="l00105"></a>00105 
<a name="l00109"></a><a class="code" href="structiMessageReceiver.html">00109</a> <span class="keyword">struct </span><a class="code" href="structiMessageReceiver.html" title="Implement this interface if you are interested in receiving messages.">iMessageReceiver</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00110"></a>00110 {
<a name="l00111"></a>00111   SCF_INTERFACE (<a class="code" href="structiMessageReceiver.html" title="Implement this interface if you are interested in receiving messages.">iMessageReceiver</a>, 0, 0, 1);
<a name="l00112"></a>00112 
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiMessageReceiver.html#a9cbdd91c224c138a044491eb36148d8a" title="Receive a message for a specific message id.">ReceiveMessage</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> msg_id, <a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a>* sender,
<a name="l00125"></a>00125       <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; ret, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params) = 0;
<a name="l00126"></a>00126 };
<a name="l00127"></a>00127 
<a name="l00131"></a><a class="code" href="structiMessageSender.html">00131</a> <span class="keyword">struct </span><a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00132"></a>00132 {
<a name="l00133"></a>00133   SCF_INTERFACE (<a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a>, 0, 0, 1);
<a name="l00134"></a>00134 
<a name="l00139"></a>00139   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiMessageSender.html#a04171a2166b44310cb7de80d2dc9ab5f" title="This method is called by the channel if some message dispatcher is removed.">MessageDispatcherRemoved</a> (
<a name="l00140"></a>00140       <a class="code" href="structiMessageDispatcher.html" title="This is a message dispatcher.">iMessageDispatcher</a>* dispatcher) = 0;
<a name="l00141"></a>00141 };
<a name="l00142"></a>00142 
<a name="l00150"></a><a class="code" href="structiMessageReceiverFilter.html">00150</a> <span class="keyword">struct </span><a class="code" href="structiMessageReceiverFilter.html" title="This is a filter used for a message dispatcher.">iMessageReceiverFilter</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00151"></a>00151 {
<a name="l00152"></a>00152   SCF_INTERFACE (<a class="code" href="structiMessageReceiverFilter.html" title="This is a filter used for a message dispatcher.">iMessageReceiverFilter</a>, 0, 0, 1);
<a name="l00153"></a>00153 
<a name="l00155"></a>00155   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiMessageReceiverFilter.html#ae74d3b4983710209701980fff062c72c" title="Return true if this receiver is ok for receiving messages.">IsValidReceiver</a> (<a class="code" href="structiMessageReceiver.html" title="Implement this interface if you are interested in receiving messages.">iMessageReceiver</a>* receiver) = 0;
<a name="l00156"></a>00156 };
<a name="l00157"></a>00157 
<a name="l00163"></a><a class="code" href="structiMessageDispatcher.html">00163</a> <span class="keyword">struct </span><a class="code" href="structiMessageDispatcher.html" title="This is a message dispatcher.">iMessageDispatcher</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00164"></a>00164 {
<a name="l00165"></a>00165   SCF_INTERFACE (<a class="code" href="structiMessageDispatcher.html" title="This is a message dispatcher.">iMessageDispatcher</a>, 0, 0, 1);
<a name="l00166"></a>00166 
<a name="l00177"></a>00177   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiMessageDispatcher.html#a04175c81128399810e1b5c0637f5d359" title="Send a message for a specific message id.">SendMessage</a> (<a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params,
<a name="l00178"></a>00178       iCelDataArray* ret = 0) = 0;
<a name="l00179"></a>00179 };
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 <span class="preprocessor">#endif // __CEL_PL_MESSAGING</span>
<a name="l00183"></a>00183 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
